C - Chain Reaction CodeForces - 608C

There are n beacons located at distinct positions on a number line. The i-th beacon has position ai and power level bi. When the i-th beacon is activated, it destroys all beacons to its left (direction of decreasing coordinates) within distance bi inclusive. The beacon itself is not destroyed however. Saitama will activate the beacons one at a time from right to left. If a beacon is destroyed, it cannot be activated.

Saitama wants Genos to add a beacon strictly to the right of all the existing beacons, with any position and any power level, such that the least possible number of beacons are destroyed. Note that Genos’s placement of the beacon means it will be the first beacon activated. Help Genos by finding the minimum number of beacons that could be destroyed.

Input
The first line of input contains a single integer n (1 ≤ n ≤ 100 000) — the initial number of beacons.

The i-th of next n lines contains two integers ai and bi (0 ≤ ai ≤ 1 000 000, 1 ≤ bi ≤ 1 000 000) — the position and power level of the i-th beacon respectively. No two beacons will have the same position, so ai ≠ aj if i ≠ j.

Output
Print a single integer — the minimum number of beacons that could be destroyed if exactly one beacon is added.

Examples
Input
4
1 9
3 1
6 1
7 4
Output
1
Input
7
1 1
2 1
3 1
4 1
5 1
6 1
7 1
Output
3
Note
For the first sample case, the minimum number of beacons destroyed is 1. One way to achieve this is to place a beacon at position 9 with power level 2.

For the second sample case, the minimum number of beacons destroyed is 3. One way to achieve this is to place a beacon at position 1337 with power level 42.

dp问题,但一开始思路有问题:由于最右侧的灯随意选择,则可以让其摧毁从右往左任意盏灯,误以为可以自由选择开关灯的数目,于是得出如下代码

#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
const int N = 201000;
const int M = 1000001;

struct ss
{
    int p, s, S;
} a[N];
int dp[M + 5]={0};
int cmp(ss s1, ss s2) { return s1.p < s2.p; }

int main()
{
    int n;
    cin >> n;
    for (int i = 1; i <= n; i++)
    {
        cin >> a[i].p >> a[i].s;
        a[i].S = a[i].p - a[i].s - 1;
    }
    sort(a + 1, a + n + 1, cmp);
    int cc = 2;
    dp[a[1].p]=1;
    for (int i = a[1].p+1; i <= M; i++)
    {
        if (i == a[cc].p)
        {
            if(a[cc].S>=0)
            dp[i] = max(dp[i - 1], dp[a[cc].S] + 1);
            else
            {
                dp[i] = dp[i - 1];
            }
            cc++;
        }
        else
            dp[i] = dp[i - 1];
    }
    cout << n - dp[M] << endl;
    system("pause");
    return 0;
}

实际上,只要没被摧毁,灯就应该是亮的

#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
const int N = 201000;
const int M = 1000001;

struct ss
{
    int p, s, S;
} a[N];
int dp[M + 5];
int cmp(ss s1, ss s2) { return s1.p < s2.p; }

int main()
{
    int n;
    cin >> n;
    for (int i = 1; i <= n; i++)
    {
        cin >> a[i].p >> a[i].s;
        a[i].S = a[i].p - a[i].s - 1;
    }
    int maxn=0;
    sort(a + 1, a + n + 1, cmp);
    int cc = 1;
    for (int i = 0; i <= M; i++)
    {
        if (i == a[cc].p)
        {
            if (a[cc].S >= 0)
            {
                dp[i] = dp[a[cc].S] + 1;
            }
            else
                dp[i] = 1;
            cc++;
        }
        else
            dp[i] = dp[i - 1];
            maxn=max(maxn,dp[i]);
    }
    cout << n - maxn << endl;
    return 0;
}
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值